function x_btoa = pds_apply(model_pds,xb);
    
    xb=div(xb);
    
    p=model_pds.p;
    xa_moy=model_pds.xa_mean;
    xb_moy=model_pds.xb_mean;
    
    x_btoa.d=(xb.d-ones(size(xb.d,1),1) * xb_moy.d') *p.d;         // application du modèle PDS
    x_btoa.d=x_btoa.d + ones(size(x_btoa.d,1),1) * xa_moy.d';      // rajout de la moyenne de xa
  
    x_btoa.i=xb.i;
    x_btoa.v=model_pds.p.v;
    x_btoa=savgol(x_btoa,2*model_pds.window+1,0);
    
    
endfunction
